%define base %(echo %{_prefix} | sed -e s,/usr.*$,,)
%define pfx /opt/freescale/rootfs/%{_target_cpu}
%define __os_install_post %{nil}

Summary         : Simple direct hardware access module and user application example package
Name            : ProtoDriver
Version         : 1.0
Release         : 1
License         : Public Domain, not copyrighted
Vendor          : Logic Product Devlopment
Packager        : Jemiah Aitch
Group           : Applications Engineering
Source          : %{name}-%{version}.tar.gz
BuildRoot       : %{_tmppath}/%{name}
Prefix          : %{pfx}

%Description
%{summary}

Notes:

You need to have a built unpacked kernel source tree available
via $RPM_BUILD_DIR/linux.

We build spoofed, so gcc == the cross compiler

You can override: KERNELDIR, ARCH by passing these on the make command line

%Prep
%setup

%Build
KSRC_DIR=${PKG_KERNEL_PATH_PRECONFIG:-$RPM_BUILD_DIR/linux}
KBOUT="$(eval echo $PKG_KERNEL_KBUILD_PRECONFIG)"
KBOUT=${KBOUT:-$KSRC_DIR}
CFG_PATH="$KBOUT/.config"
if [ $LINTARCH = ppc -a -f $KSRC_DIR/arch/powerpc/Kconfig ]
then
    if ! grep -q PPC_MERGE $KSRC_DIR/arch/powerpc/Kconfig
    then
        LINTARCH=powerpc
    else
        if [ -n "$CFG_PATH" ]
        then
            if grep -q 'CONFIG_PPC_MERGE=y' $CFG_PATH
            then
                LINTARCH=powerpc
            fi
        else
            LINTARCH=powerpc
        fi
    fi
fi
if [ ! -f $KBOUT/.config ]
then
    cat <<TXT
You need a built unpacked kernel source tree in:
$KBOUT
to build kernel modules
TXT
    exit 1
fi

cd proto
make KERNELDIR=$KBOUT ARCH=$LINTARCH
cd ../protoUserApp
make protoUserApp
cd ..

%Install
rm -rf $RPM_BUILD_ROOT

KSRC_DIR=${PKG_KERNEL_PATH_PRECONFIG:-$RPM_BUILD_DIR/linux}
KBOUT="$(eval echo $PKG_KERNEL_KBUILD_PRECONFIG)"
KBOUT=${KBOUT:-$KSRC_DIR}

if [ -f $KBOUT/include/config/kernel.release ]
then
    KVER=`cat $KBOUT/include/config/kernel.release`
else
    KVER="`perl -e '$/ = ""; $_ = <>; m,VERSION\s*=\s*(\d)\s*PATCHLEVEL\s*=\s*(\d+)\s*SUBLEVEL\s*=\s*(\d+)\s*EXTRAVERSION[ \t]*=[ \t]*(\S*),m; print  "$1.$2.$3$4"' $KSRC_DIR/Makefile`"
fi
mkdir -p $RPM_BUILD_ROOT/%{pfx}/%{base}/lib/modules/$KVER/misc/
cp proto/*.ko $RPM_BUILD_ROOT/%{pfx}/%{base}/lib/modules/$KVER/misc/
cp protoUserApp/protoUserApp $RPM_BUILD_ROOT/%{pfx}/%{base}/home/root/.
%Clean
cd proto
make clean
cd ../protoUserApp
make clean
cd ..

%Files
%defattr(-,root,root)
%{pfx}/*

